<?php
/*
	SHChat
	by Scripthosting.net
	http://www.shchat.net

	Autor: Jan-Michael Fuhrmann
	info@scripthosting.net
*/

class Format {	
	
	const FORMAT_VERSION = "00400";

	
	/**
	 * Returns a Timestamp for given seconds
	 * @param $seconds
	 * @return String
	 */
	public function getTime($seconds)
	{
	    $units = array( "Tag|e"=>86400, 
	                    "Stunde|n"=>3600,
	                    "Minute|n"=>60,
	                    "Sekunde|n"=>1
	                    );
	
	    if($seconds < 1) {
	        return "< 1 Sekunde";
	    }
	
		else	
		{
	        $show = false;
	        $ausgabe = "";
	        foreach($units as $key=>$value) 
	        {
	            $t = floor($seconds/$value);
	            $seconds = $seconds%$value;
	            list($s, $pl) = explode("|", $key);
	            if($t > 0 || $show) {
	                if($t == 1) {
	                    $ausgabe .= $t." ".$s.", ";
					} 
	
					else {
		                    $ausgabe .= $t." ".$s.$pl.", ";
					}
					$show = true;
	            }
	        }
	        $ausgabe = substr($ausgabe, 0, strlen($ausgabe)-2);
	        return $ausgabe;
	    }
	}	
		
	
	/**
	 * Returns formatted Time
	 * @param $seconds
	 * @return String
	 */	
	public function getFormatTime( $seconds ){
		
	    $units = array("Stunde|n"=>3600,
	                    "Minute|n"=>60,
	                    "Sekunde|n"=>1
	                    );
	
	    if($seconds < 1) {
	        return "00:00:00";
	    }
	
		else	
		{
	        $show = false;
	        $ausgabe = "";
	        foreach( $units as $key=>$value ) 
	        {
	            $t = floor( $seconds/$value );
	            $seconds = $seconds%$value;
	            	
				if($t<10){$t = "0".$t;}
				$ausgabe .= $t.":";
			} 
	
	        $show = true;
	        $ausgabe = substr($ausgabe, 0, strlen($ausgabe)-1);
	        
	        return $ausgabe;
	    }
	}
}
?>